<?php

require_once P2_LIBRARY_DIR . '/p2util.class.php';
require_once P2_LIBRARY_DIR . '/filectl.class.php';
require_once 'HTTP/Client.php';

/**
 * BbsMapNX
 *
 * -zXg̑Ή\쐬AɊÂăzXg̓s
 */
class BbsMap {

    // {{{ getMapping()

    /**
     * 2chj[p[XA-zXg̑Ή\쐬
     */
    function getMapping()
    {
        global $_conf, $_info_msg_ht;
        static $map = NULL;
        
        // ݒ
        $bbsmenu_url = 'http://menu.2ch.net/bbsmenu.html';
        $map_cache_path = $_conf['prefdir'] . '/p2_cache/host_bbs_map.txt';
        $map_cache_lifetime = 600; // TTL͏Z߂
        
        // LbVmF
        if (!is_null($map)) {
            return $map;
        } elseif (file_exists($map_cache_path)) {
            $mtime = filemtime($map_cache_path);
            $expires = $mtime + $map_cache_lifetime;
            if (time() > $expires) {
                $map_cahce = file_get_contents($map_cache_path);
                $map = unserialize($map_cahce);
                return $map;
            }
        }
        
        // j[_E[h
        $client = &new HTTP_Client;
        if (isset($mtime)) {
            $client->setDefaultHeader('If-Modified-Since', gmdate('D, d M Y H:i:s', $mtime) . ' GMT');
        }
        $code = $client->get($uri);
        if ($code == 304) {
            $map_cahce = file_get_contents($map_cache_path);
            $map = unserialize($map_cahce);
            return $map;
        } elseif ($code != 200) {
            $_info_msg_ht .= sprintf('<p>rep2 error: BbsMap: HTTP %d - %s _E[hł܂łB</p>', $code, htmlspecialchars($bbsmenu_url));
            if (file_exists($map_cache_path)) {
                $map_cahce = file_get_contents($map_cache_path);
                $map = unserialize($map_cahce);
            } else {
                $map = FALSE;
            }
            return $map;
        }
        $response =& $client->currentResponse();
        
        // p[X
        $regex = '!<A HREF=http://(\w+\.(?:2ch\.net|bbspink\.com|machi\.to|mathibbs\.com))/(\w+)/(?: TARGET=_blank)?>(.+?)</A>!';
        preg_match_all($regex, $response['body'], $matches, PREG_SET_ORDER);
        
        $map = array();
        foreach ($matches as $match) {
            $host = $match[1];
            $bbs  = $match[2];
            $itaj = $match[3];
            $type = BbsMap::detectHostType($host);
            if (!isset($map[$type])) {
                $map[$type] = array();
            }
            $map[$type][$bbs] = array('host' => $host, 'itaj' => $itaj);
        }
        
        // LbV
        $map_cache = serialize($map);
        if (FileCtl::file_write_contents($map_cache_path, $map_cache) === FALSE) {
            $errmsg = sprintf('Error: cannot write file. (%s)', htmlspecialchars($map_cache_path));
            die($errmsg);
        }
        
        return $map;
    }

    // }}}
    // {{{ getCurrentHost()

    /**
     * ŐṼzXg擾
     */
    function getCurrentHost($host, $bbs)
    {
        global $_info_msg_ht;
        
        // }bsOǂݍ
        $map = BbsMap::getMapping();
        if (!$map) {
            return $host;
        }
        $type = BbsMap::detectHostType($host);
        
        // `FbN
        if (isset($map[$type]) && isset($map[$type][$bbs])) {
            $new_host = $map[$type][$bbs]['host'];
            if ($host != $new_host) {
                // ړ]o炨CɔACɃXAŋߓǂ񂾃Xœ
                $msg_fmt = '<p>rep2 info: zXg̈ړ]o܂B(%s/%s  %s/%s)<br>';
                $msg_fmt .= 'CɔACɃXAŋߓǂ񂾃Xœ܂B</p>'
                $_info_msg_ht .= sprintf($msg_fmt, $host, $bbs, $new_host, $bbs);
                BbsMap::syncFav();
                $host = $new_host;
            }
        }
        
        return $host;
    }

    // }}}
    // {{{ getBbsName()

    /**
     * LONG擾
     */
    function getBbsName($host, $bbs)
    {
        // }bsOǂݍ
        $map = BbsMap::getMapping();
        if (!$map) {
            return $bbs;
        }
        $type = BbsMap::detectHostType($host);
        
        // `FbN
        if (isset($map[$type]) && isset($map[$type][$bbs])) {
            $itaj = $map[$type][$bbs]['itaj'];
        } else {
            $itaj = $bbs;
        }
        
        return $itaj;
    }

    // }}}
    // {{{ syncBrd()

    /**
     * CɔȂǂbrdt@C𓯊
     */
    function syncBrd($brd_path)
    {
        global $_conf, $_info_msg_ht;
        static $done = array();
        
        // {{{ Ǎ
        
        if (isset($done[$brd_path])) {
            return;
        }
        $lines = BbsMap::readData($brd_path);
        if ($lines === FALSE) {
            return;
        }
        $map = BbsMap::getMapping();
        if (!$map) {
            return;
        }
        $pre_hash = md5(serialize($lines));
        $neolines = array();
        
        // }}}
        // {{{ 
        
        foreach ($lines as $line) {
            $setitaj = FALSE;
            $data = explode("\t", rtrim($line, "\n"));
            $hoge = $data[0]; // \?
            $host = $data[1];
            $bbs  = $data[2];
            $itaj = $data[3];
            $type = BbsMap::detectHostType($host);
            
            if (isset($map[$type]) && isset($map[$type][$bbs])) {
                $newhost = $map[$type][$bbs]['host'];
                if ($itaj === '') {
                    $itaj = $map[$type][$bbs]['itaj'];
                    if ($itaj != $bbs) {
                        $setitaj = TRUE;
                    } else {
                        $itaj = '';
                    }
                }
            }
            
            if ($host != $newhost || $setitaj) {
                $neolines[] = "{$hoge}\t{$newhost}\t{$bbs}\t{$itaj}\n";
            } else {
                $neolines[] = $line;
            }
        }
        
        // }}}
        // {{{ 
        
        $new_hash = md5(serialize($neolines));
        if (strcmp($pre_hash, $new_hath) != 0) {
            BbsMap::writeData($brd_path, $neolines);
            $_info_msg_ht .= sprintf('<p>rep2 info: %s 𓯊܂B</p>', htmlspecialchars($brd_path));
        } else {
            $_info_msg_ht .= sprintf('<p>rep2 info: %s ͕ύX܂łB</p>', htmlspecialchars($brd_path));
        }
        $done[$brd_path] = TRUE;
        
        // }}}
    }

    // }}}
    // {{{ syncIdx()

    /**
     * CɃXȂǂidxt@C𓯊
     */
    function syncIdx($idx_path)
    {
        global $_conf, $_info_msg_ht;
        static $done = array();
        
        // {{{ Ǎ
        
        if (isset($done[$idx_path])) {
            return;
        }
        $lines = BbsMap::readData($idx_path);
        if ($lines === FALSE) {
            return;
        }
        $map = BbsMap::getMapping();
        if (!$map) {
            return;
        }
        $pre_hash = md5(serialize($lines));
        $neolines = array();
        
        // }}}
        // {{{ 
        
        foreach ($lines as $line) {
            $data = explode('<>', rtrim($line, "\n"));
            $host = $data[10];
            $bbs  = $data[11];
            $type = BbsMap::detectHostType($host);
            
            if (isset($map[$type]) && isset($map[$type][$bbs])) {
                $newhost = $map[$type][$bbs]['host'];
            }
            
            if ($host != $newhost) {
                $data[10] = $newhost;
                $neolines[] = implode('<>', $data) . "\n";
            } else {
                $neolines[] = $line;
            }
        }
        
        // }}}
        // {{{ 
        
        $new_hash = md5(serialize($neolines));
        if (strcmp($pre_hash, $new_hath) != 0) {
            BbsMap::writeData($idx_path, $neolines);
            $_info_msg_ht .= sprintf('<p>rep2 info: %s 𓯊܂B</p>', htmlspecialchars($idx_path));
        } else {
            $_info_msg_ht .= sprintf('<p>rep2 info: %s ͕ύX܂łB</p>', htmlspecialchars($idx_path));
        }
        $done[$idx_path] = TRUE;
        
        // }}}
    }

    // }}}
    // {{{ syncFav()

    /**
     * CɔACɃXAŋߓǂ񂾃X𓯊
     */
    function syncFav()
    {
        global $_conf;
        BbsMap::syncBrd($_conf['favita_path']);
        BbsMap::syncIdx($_conf['favlist_file']);
        BbsMap::syncIdx($_conf['rct_file']);
    }

    // }}}
    // {{{ readData()

    /**
     * XVÕf[^ǂݍ
     */
    function readData($path)
    {
        if (!file_exists($path)) {
            return FALSE;
        }
        
        $lines = file($path);
        if (!$lines) {
            return FALSE;
        }
        
        return $lines;
    }

    // }}}
    // {{{ writeData()

    /**
     * XṼf[^
     */
    function writeData($path, $neolines)
    {
        if (is_array($neolines) && count($neolines) > 0) {
            $cont = implode('', $neolines);
        /*} elseif (is_scalar($neolines)) {
            $cont = strval($neolines);*/
        } else {
            $cont = '';
        }
        if (FileCtl::file_write_contents($syncfile, $cont) === FALSE) {
            $errmsg = sprintf('Error: cannot write file. (%s)', htmlspecialchars($syncfile));
            die($errmsg);
        }
    }

    // }}}
    // {{{ detectHostType()

    /**
     * zXg̎ނ𔻒肷
     */
    function detectHostType($host)
    {
        if (P2Util::isHostBbsPink($host)) {
            $type = 'bbspink';
        } elseif (P2Util::isHost2chs($host)) {
            $type = '2channel';
        } elseif (P2Util::isHostMachiBbs($host)) {
            $type = 'machibbs';
        } elseif (P2Util::isHostJbbsShitaraba($host)) {
            $type = 'jbbs';
        } else {
            $type = 'others';
        }
        return $type;
    }

    // }}}

}

?>
